package me.km.utils;

public class TableUtils {
    public static String getTable(int width, String color, String... args) {
        width = 9 * width - 1; // ([ ] + [│]) - [─] = 1
        StringBuilder sb = new StringBuilder(color).append("│ ");
        for(String s : args) {
            sb.append("§r");
            sb.append(getStringWithMaxLength(s, width));
            sb.append(color).append("│ ");
        }
        sb.deleteCharAt(sb.length() - 1);
        return sb.toString();
    }

    public static String getTableMiddle(int width, int columns, String color) {
        StringBuilder sb = new StringBuilder(color).append("├");
        for(int i = 0; i < columns; i++) {
            for(int j = 0; j < width; j++) {
                sb.append("─");
            }
            sb.append("┼");
        }
        sb.setCharAt(sb.length() - 1, '┤');
        return sb.toString();
    }

    public static String getTableStart(int width, int columns, String color) {
        StringBuilder sb = new StringBuilder(color).append("┌");
        for(int i = 0; i < columns; i++) {
            for(int j = 0; j < width; j++) {
                sb.append("─");
            }
            sb.append("┬");
        }
        sb.setCharAt(sb.length() - 1, '┐');
        return sb.toString();
    }

    public static String getTableEnd(int width, int columns, String color) {
        StringBuilder sb = new StringBuilder(color).append("└");
        for(int i = 0; i < columns; i++) {
            for(int j = 0; j < width; j++) {
                sb.append("─");
            }
            sb.append("┴");
        }
        sb.setCharAt(sb.length() - 1, '┘');
        return sb.toString();
    }

    private static int getCharWidth(char c) {
        switch(c) {
            case 'f':
            case 'k':
                return 5;
            case 'I':
            case 't':
            case ' ':
            case '[':
            case ']':
            case '{':
            case '}':
            case '(':
            case ')':
                return 4;
            case 'l':
                return 3;
            case ';':
            case ',':
            case '.':
            case 'i':
                return 2;
        }
        return 6;
    }

    private static String getStringWithMaxLength(String s, int max) {
        int sum = 0;
        StringBuilder sb = new StringBuilder();
        for(int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            if(c == '§') {
                i++;
                continue;
            }
            int width = getCharWidth(c);
            if(sum + width > max) {
                break;
            }
            sum += width;
            sb.append(c);
        }
        sb.append("§0");
        while(sum + 4 <= max) {
            sb.append(' ');
            sum += 4;
        }
        while(sum + 2 <= max) {
            sb.append('˼');
            sum += 2;
        }
        while(sum + 1 <= max) {
            sb.append('ˈ');
            sum++;
        }
        return sb.toString();
    }
}
